function find_multistats(self)
	if self.Logic == MultiStats then
		MULTI_STATS = self
	end
end

function CreateHUDElement(x, y, image)
	local _CreateHUDElement = ffi.cast("ObjectA* (*__thiscall)(ObjectA*, int, int, int, int, int, int)", 0x4D52F0)
	local object = _CreateHUDElement(MULTI_STATS, 0, x, y, 9999, 0x520624, 0)
	object:SetImage(image)
	return object
end

function UpdateBossBar(self)
	if self.BossHealth ~= nil then
		self.bossbar.DrawFlags.NoDraw = false
		self.bossbar.I = (self.BossHealth - self.BossHealth % 5)/5+1
		self.bossbar:SetFrame(self.bossbar.I)
	else
		self.bossbar.DrawFlags.NoDraw = true
	end
	
	
end


function det(a,b,c, d,e,f, g,h,i)
  return a*e*i+b*f*g+c*d*h-c*e*g-b*d*i-a*f*h
end

function GetJumpTrajectory(x1,y1, x2,y2, x3,y3)
  local DET = det(x1*x1, x1, 1, x2*x2, x2, 1, x3*x3, x3, 1)
  local res = {}
  res[0] = det(y1, x1, 1, y2, x2, 1, y3, x3, 1)/DET
  res[1] = det(x1*x1, y1, 1, x2*x2, y2, 1, x3*x3, y3, 1)/DET
  res[2] = det(x1*x1, x1, y1, x2*x2, x2, y2, x3*x3, x3, y3)/DET
  return res
end

local A1, A2 = 727595, 798405  -- 5^17=D20*A1+A2
local D20, D40 = 1048576, 1099511627776  -- 2^20, 2^40
local X1, X2 = 0, 1
function rand()
    local U = X2*A2
    local V = (X1*A2 + X2*A1) % D20
    V = (V*D20 + U) % D40
    X1 = math.floor(V/D20)
    X2 = V - X1*D20
    return V/D40
end

function ShakeScreen(self)
	CameraToPoint(GetClaw().X-5+rand()*10,GetClaw().Y-5+rand()*10)
end

function GetCannonCordX(self, i)
	if i == 0 or i == 1 or i == 2 then
		return self.destroyer.X - 273 + i * 64
	elseif i == 3 or i == 4 or i == 5 then
		return self.destroyer.X - 209 + i * 64
	end
end

function GetCannonCordY(self)
	return self.destroyer.Y + 264
end

function CannonShoot(self, i)
	CreateObject {x=GetCannonCordX(self, i), y=GetCannonCordY(self), z=1000, name="DestroyerBomb", logic="CustomLogic", image="CUSTOM_DESTROYERBOMB"}
end

----------------------------------------------------------------------------

function DestroyerShootCommand(self)
	self.destroyer:SetAnimation("GAME_FORWARD50")
	--self.destroyer:SetAnimation("CUSTOM_BOMBARDMENTCOMMAND")
	
end

function SummonCaptain(self)
	self.vadmrl = CreateObject {x=82300, y=5025, z=4000, name="ViceAdmiral", logic="CustomLogic", image="LEVEL_TIGER", UserRect1 = {0,0,0,0}, UserRect2 = {0,0,0,0}}
end

function RauxEngagement(self)
	
	self.RauxDummy = CreateObject {x=self.Raux.X, y=self.Raux.Y, z=4000, logic="DoNothingNormal", image="LEVEL_RAUX"}
	self.RauxDummy.I = 806
	self.RauxDummy:SetFrame(806)
	
	self.RauxDummyStartX = self.Raux.X
	self.RauxDummyStartY = self.Raux.Y
	if GetClaw().X > 82950 then
		self.RauxDummyTargetX = 82764
	else
		self.RauxDummyTargetX = 83100
	end
	self.RauxDummyTargetY = 5260
	self.RauxDummyXDiff = self.RauxDummyTargetX - self.RauxDummyStartX
	self.RauxDummyFlyTime = GetTime()
	self.RauxDummyFlyLimit = GetTime() + 1000.0
	self.RauxDummyFlyMaxX = ( self.RauxDummyTargetX + self.RauxDummyStartX ) / 2.0
	self.RauxDummyFlyMaxY = math.min(self.RauxDummyStartY, self.RauxDummyTargetY)
	local tab = GetJumpTrajectory(self.RauxDummyStartX, self.RauxDummyStartY, self.RauxDummyTargetX, self.RauxDummyTargetY, self.RauxDummyFlyMaxX, self.RauxDummyFlyMaxY)
	self.RauxDummyFlyA = tab[0]
	self.RauxDummyFlyB = tab[1]
	self.RauxDummyFlyC = tab[2]
	
	self.BossActive = 0
end

function RauxWithdrawal(self)
	
	self.RauxDummy = CreateObject {x=self.Raux.X, y=self.Raux.Y, z=4000, logic="DoNothingNormal", image="LEVEL_RAUX"}
	self.RauxDummy.I = 806
	self.RauxDummy:SetFrame(806)
	self.RauxDummy.DrawFlags.Mirror = true
	
	self.RauxDummyStartX = self.Raux.X
	self.RauxDummyStartY = self.Raux.Y
	
	self.RauxDummyTargetX = 83264
	self.RauxDummyTargetY = 5045
	
	self.RauxDummyXDiff = self.RauxDummyTargetX - self.RauxDummyStartX
	self.RauxDummyFlyTime = GetTime()
	self.RauxDummyFlyLimit = GetTime() + 1000.0
	self.RauxDummyFlyMaxX = ( self.RauxDummyTargetX + self.RauxDummyStartX ) / 2.0
	self.RauxDummyFlyMaxY = math.min(self.RauxDummyStartY, self.RauxDummyTargetY)
	local tab = GetJumpTrajectory(self.RauxDummyStartX, self.RauxDummyStartY, self.RauxDummyTargetX, self.RauxDummyTargetY, self.RauxDummyFlyMaxX, self.RauxDummyFlyMaxY)
	self.RauxDummyFlyA = tab[0]
	self.RauxDummyFlyB = tab[1]
	self.RauxDummyFlyC = tab[2]
	
	self.BossActive = 0
end

function main(self)	
if GetClaw().X > 81847 and GetClaw().X < 86391 then -- Prevents Raux from laughing when it's not bossfight
	PLAY_AREA = ffi.cast("Rect*", 0x535840)[0]
	local centerX = (PLAY_AREA.Right+1)/2-1
	local centerY = (PLAY_AREA.Bottom+1)/2-1
	local centerBossName = (PLAY_AREA.Bottom+1)*0.3-1
	local endBossName = PLAY_AREA.Right + 138
	local barY = ((PLAY_AREA.Bottom+1)*0.9+15)
	local bossnameStartY = PLAY_AREA.Top-66
	
	
	
	-- 82941- 5005
	if self.destroyer == nil then -- Create Destroyer
		self.destroyer = CreateObject {x=82505, y=5005, z=-100, logic="AniCycleNormal", image="CUSTOM_DESTROYER"}
		self.destroyer.I = 1
		self.destroyer.Flags.AlwaysActive = true
		AniCycleNormal(self.destroyer)
		self.destroyer:SetAnimation("GAME_NULL")
		--self.destroyer:SetFrame(1)
	end
	
	if self.State == 0 then
        self.State = 1
        self.AttackRect = {-128,-128,128,128}
        self.AttackTypeFlags = ObjectType.Player
		
		self.Attempt = Attempt()
		self.cannonade = -1
		--self.stage = 0
		
		self.Achievements = GetObject(7250)
		if GetTime()+self.Achievements.TimePenalty[1] <= 780000 then -- finished speedrun in less than 13 minutes
			self.Achievements.achievements_input[15] = 1
		end
    end
	--TextOut(self.stage)
	if self.Attempt < Attempt() then
		self.Attempt = Attempt()
		--TextOut(Attempt())
		if ( self.stage <= 26 or ( self.stage == 27 and self.Raux ~= nil ) ) and self.stage < 32 then
			self.stage = 11
			self.Raux:Destroy()
			self.Raux = nil
			self.Raux = CreateObject {x=83264, y=4992, z=4000, logic="Raux", image="LEVEL_RAUX"}
			self.BossHealth = 100
			self.BossActive = 1
			SetBoss(self.Raux)
			self.destroyer:SetAnimation("GAME_NULL")
			if self.vadmrl ~= nil then
				self.vadmrl:Destroy()
				self.vadmrl = nil
			end
		end
		if self.stage == 41 and self.RedTail ~= nil then
			--self.RedTail:Destroy()
			self.RedTail.State = 0
			self.stage = 41
			self.achievementRedTail = 1
			--self.RedTail.RTWind.Speed = 0
			
		end
	end
	
	if self.destroyer.I == 10 and self.cannonade == -1 then -- Destroyer attacking
		self.cannonade = 0
		self.TimeCounter2 = GetTime()
	end
	
	if self.cannonade >= 0 and self.TimeCounter2 + 500 < GetTime() then
		CannonShoot(self, self.cannonade)
		self.TimeCounter2 = GetTime()
		self.cannonade = self.cannonade + 1
	end
	if self.cannonade >= 6 then
		self.cannonade = -1
	end
		
	if self.RauxDummy ~= nil and self.stage < 28 then -- handles Raux jumping, in practise kills him, then creates dummy that jumps, then kills dummy and creates a new Raux in a new position
		if self.RauxDummyFlyTime ~= nil and self.RauxDummyFlyLimit ~= nil then
			if GetTime() >= self.RauxDummyFlyTime and GetTime() <= self.RauxDummyFlyLimit then -- raux jump
				local Time = GetTime()
				local Progress = ( Time - self.RauxDummyFlyTime ) / ( self.RauxDummyFlyTime - self.RauxDummyFlyLimit ) * (-1)
				local x = self.RauxDummyStartX + self.RauxDummyXDiff * Progress
				self.RauxDummy.X = x
				self.RauxDummy.Y = self.RauxDummyFlyA * x * x + self.RauxDummyFlyB * x + self.RauxDummyFlyC
			end
			if GetTime() > self.RauxDummyFlyLimit then
				self.Raux = CreateObject {x=self.RauxDummy.X, y=self.RauxDummy.Y, z=4000, logic="Raux", image="LEVEL_RAUX"}
				self.Raux.Health = self.BossHealth
				--self.Raux.State = 2028
				local claw = GetClaw()
				if self.Raux.X < claw.X then
					self.Raux.DrawFlags.Mirror = true
				end
				self.BossActive = 1
				self.RauxDummy:Destroy()
				self.RauxDummy = nil
			end
		end
		
	end
		
	if self.stage ~= nil then -- move the Destroyer till it's in intended position
		if self.stage > 1 and self.stage < 12 and self.destroyer.X < 83005 then
			self.destroyer.X = self.destroyer.X + 1
		elseif self.stage >= 41 and self.destroyer.X < 87777 then
			self.destroyer.X = self.destroyer.X + 1
		end
	end
		
	if self.stage == 0 then -- set music
		SetMusic("BOSS")
		self.stage = 1
		--self.stage = 30
		--self.TimeCounter = GetTime() + 750
	end
	if self.stage == 1 then -- immobilize Claw, set respawn point
		if GetClaw().State == 24 or GetClaw().State == 8 or GetClaw().State == 9 then
			GetClaw().SetAnimation(GetClaw(), "CLAW_STAND", 100)
			GetClaw().State = 5009
			ffi.cast("int*", _nResult[0][11])[17] = GetClaw().X
			ffi.cast("int*", _nResult[0][11])[18] = GetClaw().Y
			self.stage = 2
		end
	end
	if self.stage == 2 then -- set Raux as boss, create boss health bar
		--self.Raux = GetObject(6344)
		self.Raux = CreateObject {x=83264, y=4992, z=4000, logic="Raux", image="LEVEL_RAUX"}
		self.BossHealth = 100
		self.BossActive = 1
		SetBoss(self.Raux)
		
		LoopThroughObjects(find_multistats)
		self.bossbar = CreateHUDElement(centerX, barY, "CUSTOM_BOSSBAR")
		
		CameraToObject(self.Raux)
		self.TimeCounter = GetTime()
		self.stage = 3
		
		--TextOut(self.Raux.Y)
	end
	if self.stage == 3 then -- Raux speaking
		if self.TimeCounter + 500 < GetTime() then
		
			self.objExc = CreateObject {x=GetBoss().X, y=GetBoss().Y-90, z=9000, logic="BlinkingEyes", image="GAME_EXCLAMATION"}
			
			PlaySound("CUSTOM_TRIGGER_ENEMY1")
			self.TimeCounter = GetTime()
			self.stage = 4
		end
	end
	if self.stage == 4 then -- Claw speaking
		if self.TimeCounter + 1500 < GetTime() then
			--TextOut(GetClaw().Y)
			local obj = self.objExc
			obj:Destroy()
			self.objExc = nil
			CameraToObject(GetClaw())
			ClawSound("CUSTOM_TRIGGER_CLAW1")
			self.TimeCounter = GetTime()
			self.stage = 5
		end
	end
	if self.stage == 5 then -- "Defeat LeRaux"
		if self.TimeCounter + 2000 < GetTime() then
			self.bossname1 = CreateHUDElement(centerX, bossnameStartY, "CUSTOM_BOSSNAME1")
			PlaySound("GAME_SDPT1")
			self.TimeCounter = GetTime()
			self.stage = 6
		end
	end
	if self.stage == 6 then -- bossname going in animation
		local animationLen = 2029
		self.bossname1.Y = bossnameStartY+(centerBossName-bossnameStartY)*( GetTime()-self.TimeCounter )/ animationLen
		--TextOut(self.bossname1.Y)
		if self.TimeCounter + animationLen < GetTime() then
			self.TimeCounter = GetTime()
			self.stage = 7
		end
	end
	if self.stage == 7 then -- sound
		PlaySound("GAME_SDPT2")
		self.TimeCounter = GetTime()
		self.stage = 8
	end
	if self.stage == 8 then -- shake screen, play "defeat ..." sound
		ShakeScreen()
		if self.TimeCounter + 500 < GetTime() then
			CameraToClaw()
			PlaySound("CUSTOM_TRIGGER_DEFEAT1")
			self.TimeCounter = GetTime()
			self.stage = 9
		end
	end
	if self.stage == 9 then -- wait for sound to finish
		if self.TimeCounter + 1250 < GetTime() then
			self.TimeCounter = GetTime()
			self.stage = 10
		end
	end
	if self.stage == 10 then -- bossname going out animation
		local animationLen = 750
		self.bossname1.X = centerX+(endBossName-centerX)*( GetTime()-self.TimeCounter )/ animationLen
		--TextOut(self.bossname1.X)
		if self.TimeCounter + animationLen < GetTime() then
			self.bossname1 = nil
			--self.TimeCounter = GetTime()
			self.stage = 11
		end
	end
	if self.stage == 11 then 
		GetClaw().State = 24 -- unfreeze Claw
		self.destroyer.X = 83005 -- by this time the Destroyer should already be in place 82941 5005. Set it there anyway in case player has ill fps or whatever
		self.achievementRaux = 1
		self.stage = 12
	end
	if self.stage == 12 then -- the Destroyer launches a barrage towards Claw
		DestroyerShootCommand(self)
		self.stage = 13
		self.TimeCounter = GetTime()
		
	end
	if self.stage == 13 then -- spawn a Vice Admiral
		if self.TimeCounter + 3500 < GetTime() then
			--self.TimeCounter = GetTime()
			SummonCaptain(self)
			self.stage = 14
		end
	end
	if self.stage == 14 then -- wait for Vice Admiral defeat
		if self.vadmrl.I == 950 or self.vadmrl.Health == 0 then
			self.vadmrl.Health = 0
			self.vadmrl = nil
			RauxEngagement(self)
			self.stage = 15
		end
	end
	if self.stage == 15 then -- Raux jumps back to safe spot
		if self.BossHealth <= 75 then
			RauxWithdrawal(self)
			self.stage = 16
		end
	end
	if self.stage == 16 then -- the Destroyer launches a barrage towards Claw
		DestroyerShootCommand(self)
		self.stage = 17
		self.TimeCounter = GetTime()
		
	end
	if self.stage == 17 then -- spawn a Vice Admiral
		if self.TimeCounter + 3500 < GetTime() then
			--self.TimeCounter = GetTime()
			SummonCaptain(self)
			self.stage = 18
		end
	end
	if self.stage == 18 then -- wait for Vice Admiral defeat
		if self.vadmrl.I == 950 or self.vadmrl.Health == 0 then
			self.vadmrl.Health = 0
			self.vadmrl = nil
			RauxEngagement(self)
			self.stage = 19
		end
	end
	if self.stage == 19 then -- Raux jumps back to safe spot
		if self.BossHealth <= 50 then
			RauxWithdrawal(self)
			self.stage = 20
		end
	end
	if self.stage == 20 then -- the Destroyer launches a barrage towards Claw
		DestroyerShootCommand(self)
		self.stage = 21
		self.TimeCounter = GetTime()
		
	end
	if self.stage == 21 then -- spawn a Vice Admiral
		if self.TimeCounter + 3500 < GetTime() then
			--self.TimeCounter = GetTime()
			SummonCaptain(self)
			self.stage = 22
		end
	end
	if self.stage == 22 then -- wait for Vice Admiral defeat
		if self.vadmrl.I == 950 or self.vadmrl.Health == 0 then
			self.vadmrl.Health = 0
			self.vadmrl = nil
			RauxEngagement(self)
			self.stage = 23
		end
	end
	if self.stage == 23 then -- Raux jumps back to safe spot
		if self.BossHealth <= 25 then
			RauxWithdrawal(self)
			self.stage = 24
		end
	end
	if self.stage == 24 then -- the Destroyer launches a barrage towards Claw
		DestroyerShootCommand(self)
		self.stage = 25
		self.TimeCounter = GetTime()
		
	end
	if self.stage == 25 then -- spawn a Vice Admiral
		if self.TimeCounter + 3500 < GetTime() then
			--self.TimeCounter = GetTime()
			SummonCaptain(self)
			self.stage = 26
		end
	end
	if self.stage == 26 then -- wait for Vice Admiral defeat
		if self.vadmrl.I == 950 or self.vadmrl.Health == 0 then
			self.vadmrl.Health = 0
			self.vadmrl = nil
			RauxEngagement(self)
			self.stage = 27
		end
	end
	if self.stage == 27 then -- Raux curses Claw
		if self.BossHealth <= 5 then
			self.RauxDummy2 = CreateObject {x=self.Raux.X, y=self.Raux.Y, z=4000, logic="AniCycleNormal", image="CUSTOM_RAUXSAYSNWORD"}
			self.RauxDummy2:SetAnimation("GAME_FORWARD200")
			--local claw = GetClaw()
			GetClaw().State = -1
			self.TimeCounter = GetTime()
			PlaySound("GAME_CURSE1")
			if self.RauxDummy2.X < GetClaw().X then
				self.RauxDummy2.DrawFlags.Mirror = true
			end
			--self.Raux:Destroy()
			--self.Raux = nil
			self.BossActive = 0
			
			--self.Raux = CreateObject {x=83180, y=5529, z=4000, logic="Raux", image="LEVEL_RAUX"}
			--self.Raux.DrawFlags.NoDraw = true
			self.stage = 28
		end
	end
	if self.stage == 28 then -- Raux attempts escape
		
		CameraToObject(self.RauxDummy2)
		if self.RauxDummy2.I >= 8 then
			
			self.RauxDummy3 = CreateObject {x=self.RauxDummy2.X, y=self.RauxDummy2.Y, z=4000, logic="AniCycleNormal", image="LEVEL_RAUX"}
			self.RauxDummy3:SetAnimation("LEVEL_RAUX_FASTADVANCE")
			self.RauxDummy3.DrawFlags.Mirror = true
			self.RauxDummy2:Destroy()
			self.RauxDummy2 = nil
			self.stage = 29
		end
	end
	if self.stage == 29 then -- Raux retreating
		CameraToObject(self.RauxDummy3)
		self.RauxDummy3.X = self.RauxDummy3.X + 3
		if self.RauxDummy3.X >= 83770 then
			self.RauxDummy3:SetAnimation("LEVEL_RAUX_IDLE")
			self.RauxDummy3.DrawFlags.Mirror = false
	
			self.objExc1 = CreateObject {x=self.RauxDummy3.X, y=self.RauxDummy3.Y-80, z=9000, logic="BlinkingEyes", image="GAME_EXCLAMATION"}
			
			PlaySound("LEVEL_RAUX_00840003")
			self.TimeCounter = GetTime()
			self.stage = 30
		end
	end
	if self.stage == 30 then -- Not the last laugh
		if self.TimeCounter + 750 < GetTime() then
			--if self.objExc1 ~= nil then
			local obj1 = self.objExc1
			obj1:Destroy()
			self.objExc1 = nil
			
			self.RedtaiL1 = CreateObject {x=83770, y=4990, z=4001, logic="AniCycleNormal", image="LEVEL_REDTAIL"}
			self.RedtaiL1.I = 802
			self.RedtaiL1:SetFrame(self.RedtaiL1.I)
			
			self.stage = 31
		end
	end
	if self.stage == 31 then -- Red Tail makes appearance
		--TextOut(self.RedtaiL1.Y)
		if self.RedtaiL1.Y <= 5290 then
			self.RedtaiL1.Y = self.RedtaiL1.Y + 10
			self.RedtaiL1.I = 802
			self.RedtaiL1:SetFrame(self.RedtaiL1.I)
		else
			self.RedtaiL1.I = 100
			self.RedtaiL1:SetAnimation("LEVEL_REDTAIL_IDLE")
			--DoNothingNormal(self.RauxDummy3)
			self.RauxDummy4 = CreateObject {x=self.RauxDummy3.X, y=self.RauxDummy3.Y+32, z=3500, logic="DoNothingNormal", image="LEVEL_RAUX"}
			self.RauxDummy3:Destroy()
			self.RauxDummy3 = null
			self.RauxDummy4.I = 904
			self.RauxDummy4:SetFrame(self.RauxDummy4.I)
			PlaySound("LEVEL_RAUX_00840005")
			--BossHealth = nil
			PlaySound("CUSTOM_TRIGGER_JOJO1")
			
			if self.achievementRaux == 1 then
				self.Achievements.achievements_input[2] = 1
			end
			self.BossHealth = 0
			self.TimeCounter = GetTime()
			self.stage = 32
		end
	end
	if self.stage ~= nil then
		if self.stage < 31 and self.stage > 11 then
			if GetClaw().State == 31 then
				self.achievementRaux = 0
				--TextOut("DMG Taken")
			end
		end
	end
	if self.stage == 32 then -- (not) The last laugh, Red Tail talks, setting new respawn coords
		if self.TimeCounter + 1000 < GetTime() then
			PlaySound("LEVEL_REDTAIL_01040022")
			self.objExc2 = CreateObject {x=self.RedtaiL1.X, y=self.RedtaiL1.Y-80, z=9000, logic="DoNothing", image="GAME_EXCLAMATION"}
			--local claw = GetClaw()
			GetClaw().X = 83422
			GetClaw().Y = 5295
			
			GetClaw().SetAnimation(GetClaw(), "CLAW_STAND", 100)
			GetClaw().State = 5009
			ffi.cast("int*", _nResult[0][11])[17] = 83422
			ffi.cast("int*", _nResult[0][11])[18] = 5275
			GetClaw().DrawFlags.Mirror = false
			
			self.TimeCounter = GetTime()
			self.stage = 33
		end
	end
	if self.stage == 33 then -- Claw no nonsense
		if self.TimeCounter + 1435 < GetTime() then
			--TextOut(GetClaw().Y)
			self.objExc2.DrawFlags.NoDraw = true
			CameraToObject(GetClaw())
			ClawSound("CUSTOM_TRIGGER_MEASUREDINSECONDS")
			self.TimeCounter = GetTime()
			
			self.stage = 34
		end
	end
	
	if self.stage == 34 then -- "Defeat RedTail"
		if self.TimeCounter + 3009 < GetTime() then
			self.bossname2 = CreateHUDElement(centerX, bossnameStartY, "CUSTOM_BOSSNAME2")
			PlaySound("GAME_SDPT1")
			self.TimeCounter = GetTime()
			if self.BossHealth < 100 then
				self.BossHealth = self.BossHealth + 1
			end
			self.stage = 35
		end
	end
	if self.stage == 35 then -- bossname going in animation
		local animationLen = 2029
		self.bossname2.Y = bossnameStartY+(centerBossName-bossnameStartY)*( GetTime()-self.TimeCounter )/ animationLen
			
		if self.TimeCounter + animationLen < GetTime() then
			self.TimeCounter = GetTime()
			self.stage = 36
		end
	end
	if self.stage == 36 then -- sound
		PlaySound("GAME_SDPT2")
		self.TimeCounter = GetTime()
		self.stage = 37
	end
	if self.stage == 37 then -- shake screen, play "defeat ..." sound
		ShakeScreen()
		if self.TimeCounter + 500 < GetTime() then
			CameraToClaw()
			PlaySound("CUSTOM_TRIGGER_DEFEAT2")
			self.TimeCounter = GetTime()
			self.stage = 38
		end
	end
	if self.stage == 38 then -- wait for sound to finish
		if self.TimeCounter + 1250 < GetTime() then
			self.TimeCounter = GetTime()
			self.stage = 39
		end
	end
	if self.stage == 39 then -- bossname going out animation
		local animationLen = 750
		self.bossname2.X = centerX+(endBossName-centerX)*( GetTime()-self.TimeCounter )/ animationLen
		--TextOut(self.bossname2.X)
		if self.TimeCounter + animationLen < GetTime() then
			self.bossname2 = nil
			--self.TimeCounter = GetTime()
			self.stage = 40
		end
	end
	if self.stage == 40 then 
		GetClaw().State = 24 -- unfreeze Claw, RT fight happens here
		
		self.RedTail = CreateObject {x=83770, y=5290, z=4000, name="RedTail", logic="CustomLogic", image="LEVEL_REDTAIL"}
		self.BossActive = 2
		--SetBoss(self.RedTail)
		if self.RedtaiL1 ~= nil then
			self.RedtaiL1:Destroy()
			self.RedtaiL1 = nil
		end
		self.achievementRedTail = 1
		self.stage = 41
	end
	if self.stage == 41 then -- if RT health falls to 5%, activate strong wind to push Claw tyo the wall
		--if GetClaw().Health > 0 then
		if GetClaw().State == 31 then
			self.achievementRedTail = 0
			--TextOut("DMG Taken")
		end
		if self.RedTail ~= nil then
			if self.RedTail.Health <= 5 then
				self.RedTail2 = CreateObject {x=self.RedTail.X, y=self.RedTail.Y, z=4000, logic="AniCycle", image="LEVEL_REDTAIL"}
				self.RedTail2:SetAnimation("LEVEL_REDTAIL_HEHECHYBA")
				PlaySound("LEVEL_REDTAIL_01040007")
				self.BossActive = 3
				self.RedTail:Destroy()
				self.RedTail = nil
				
				self.objExc2.X = self.RedTail2.X
				self.objExc2.Y = self.RedTail2.Y-80
				self.objExc2.DrawFlags.NoDraw = false
				
				if self.RedTail2.X <= 83622 then
					self.RTWind = CreateObject {x=83637, y=5326, z=10000, logic="ConveyorBelt", image="GAME_SOUNDICON", Speed = 400}
					self.RedTail2.DrawFlags.Mirror = true
					PlaySound("LEVEL_REDTAIL_01040020")
				else
					self.RTWind = CreateObject {x=83637, y=5326, z=10000, logic="ConveyorBelt", image="GAME_SOUNDICON", Speed = -400}
					self.RedTail2.DrawFlags.Mirror = false
					PlaySound("LEVEL_REDTAIL_01040012")
				end
				self.RTWind.DrawFlags.NoDraw = true
				self.RTWind.MoveRect = {-256,-32,256,64}
				PlaySound("LEVEL_REDTAIL_WINDWHISTLING2")
				self.OnceFlag = 0
				
				self.stage = 42
			end
		end
	end
	if self.stage ~= nil then -- stop Claw once he reaches the wall
		if self.stage >= 43 and self.stage <= 46 then
			if self.RedTail2.DrawFlags.Mirror == true then
				if GetClaw().X >= 83860 and GetClaw().Y>= 5290 then
					GetClaw().State = 5009
					if self.OnceFlag == 0 then
						GetClaw().SetAnimation(GetClaw(), "CLAW_STAND", 100)
						self.OnceFlag = 1
					end
					GetClaw().Y = 5295
					GetClaw().DrawFlags.Mirror = true
				else
					GetClaw().X = GetClaw().X + 2
				end
			else
				if GetClaw().X <= 83411 and GetClaw().Y>= 5290 then --408
					GetClaw().State = 5009
					if self.OnceFlag == 0 then
						GetClaw().SetAnimation(GetClaw(), "CLAW_STAND", 100)
						self.OnceFlag = 1
					end
					GetClaw().Y = 5295
					GetClaw().DrawFlags.Mirror = false
				else
					GetClaw().X = GetClaw().X - 2
				end
			end
			
		end
	end
	if self.stage == 42 then
		if GetClaw().State == 24 or GetClaw().State == 8 or GetClaw().State == 9 then
			GetClaw().SetAnimation(GetClaw(), "CLAW_STAND", 100)
			GetClaw().State = 24
			CameraToPoint(83622,5326)
			self.TimeCounter = GetTime()
			self.stage = 43
		end
	end
	if self.stage == 43 then
		if self.TimeCounter + 1700 < GetTime() then
			PlaySound("LEVEL_REDTAIL_01040002")
			self.TimeCounter = GetTime()
			self.stage = 44
		end
	end
	if self.stage == 44 then
		if self.TimeCounter + 1700 < GetTime() then
			PlaySound("LEVEL_REDTAIL_01040004")
			self.TimeCounter = GetTime()
			self.stage = 45
		end
	end
	if self.stage == 45 then
		if self.TimeCounter + 1268 < GetTime() then
			self.objExc2.DrawFlags.NoDraw = true
		end
		if self.TimeCounter + 1700 < GetTime() then
			ClawSound("CUSTOM_TRIGGER_SECONDMISTAKE")
			self.TimeCounter = GetTime()
			self.stage = 46
		end
	end
	if self.stage == 46 then
		if self.TimeCounter + 2000 < GetTime() then
			GetClaw().SetAnimation(GetClaw(), "CLAW_MAGIC", 100)
			--GetClaw().State = 5009
			self.stage = 47
		end
	end
	if self.stage == 47 then
		if GetClaw().I == 167 then
			if self.RedTail2.DrawFlags.Mirror then
				local dir = -1
				self.TacticalMagicClaw = CreateObject {x=GetClaw().X-20, y=GetClaw().Y-10, z=4100, logic="MagicBullet", image="GAME_MAGICCLAW", SpeedX = 800*dir}
				
			else
				local dir = 1
				self.TacticalMagicClaw = CreateObject {x=GetClaw().X+20, y=GetClaw().Y-10, z=4100, logic="MagicBullet", image="GAME_MAGICCLAW", SpeedX = 800*dir}
				
			end
			self.TimeCounter = GetTime()
			if PlayerData().MagicAmmo >= 1 then
				PlayerData().MagicAmmo = PlayerData().MagicAmmo - 1
			else
				GetClaw().Health = 1
			end
			self.stage = 48
		end
	end
	if self.stage == 48 then
		if self.TimeCounter + 100 < GetTime() then
			GetClaw().SetAnimation(GetClaw(), "CLAW_STAND", 100)
			
			self.stage = 49
		end
	end
	if self.stage == 49 then 
		local dir = 1
		if self.RedTail2.DrawFlags.Mirror then
				dir = 1 -- prawo
			else
				dir = -1
			end
		--if self.TacticalMagicClaw.X + 40 * dir <= self.RedTail2.X then
		if math.abs(self.TacticalMagicClaw.X - self.RedTail2.X) <= 40 then
			--self.TacticalMagicClaw:Destroy()
			self.TacticalMagicClaw.Y = 9000
			--self.TacticalMagicClaw = nil
			self.RedTail2:SetAnimation("LEVEL_REDTAIL_HITHIGH")
			self.hehechyba = CreateObject {x=self.RedTail2.X, y=self.RedTail2.Y-20, z=4100, logic="Bullet", image="CUSTOM_HEHECHYBA", SpeedX = 600*dir, SpeedY = 25}
			PlaySound("LEVEL_REDTAIL_01040006")
			self.TimeCounter = GetTime()
			self.stage = 50
		end 
	end 
	if self.stage == 50 then 
		if self.TimeCounter + 100 < GetTime() then
			self.RedTail2:SetAnimation("LEVEL_REDTAIL_IDLE")
			self.TimeCounter = GetTime()
			self.stage = 51
		end
	end 
	if self.stage == 51 then 
		if self.TimeCounter + 1000 < GetTime() then
			self.objExc2.X = self.RedTail2.X
			self.objExc2.Y = self.RedTail2.Y-80
			self.objExc2.DrawFlags.NoDraw = false
			PlaySound("LEVEL_REDTAIL_01040021")
			self.stage = 52
		end
	end 
	if self.stage == 52 then 
		if self.TimeCounter + 2360 < GetTime() then
			self.RedTail2:SetAnimation("LEVEL_REDTAIL_JUMP")
			PlaySound("LEVEL_REDTAIL_RTJUMP")
			self.RedTail2.SpeedY = -10
			self.stage = 53
		end
	end 
	if self.stage == 53 then 
		self.RTWind.Speed = 0
		GetClaw().State = 24
		CameraToClaw()
		CreateObject {x=83632, y=5170, z=4000, logic="EndOfLevelPowerup", image="GAME_MAPPIECE"}
		CreateObject {x=83532, y=5170, z=4000, logic="DoNothing", image="CUSTOM_ACHIEVEMENTSWARP"}
		if self.achievementRedTail == 1 then
			self.Achievements.achievements_input[3] = 1
		end
		self.Achievements.achievements_input[1] = 1
		self.hiddenwarp = CreateObject {x=83532, y=5170, z=4000, logic="SpecialPowerup", image="GAME_VERTWARP", SpeedX = 110813, SpeedY = 5109}
		self.hiddenwarp.DrawFlags.NoDraw = true
		self.BossHealth = nil
		self.stage = 54
	end 
	if self.stage == 53 or self.stage == 54 then
		if self.objExc2 ~= nil then
			self.objExc2.X = self.RedTail2.X
			self.objExc2.Y = self.RedTail2.Y-80
		end
		if self.RedTail2 ~= nil then
			if self.RedTail2.Y <= 83380 then
				self.RedTail2.X = self.RedTail2.X - 3
				self.RedTail2.Y = self.RedTail2.Y + self.RedTail2.SpeedY
				if self.RedTail2.SpeedY < 10 then
					self.RedTail2.SpeedY = self.RedTail2.SpeedY + 1
				end
			else
				self.RedTail2:Destroy()
				self.RedTail2 = nil
			end
		end
	end
	
	--if self.vadmrl ~= nil then
	--	TextOut(self.vadmrl.State)
	--end
	
	if self.bossbar ~= nil then
		UpdateBossBar(self)
	end
		
	if self.BossActive ~= nil then
		if self.BossActive == 1 then
			self.BossHealth = self.Raux.Health
		elseif self.BossActive == 2 then
			self.BossHealth = self.RedTail.Health
		elseif self.BossActive == 3 then -- allow manual control over health bar
		else
			if GetBoss() ~= nil then	
				GetBoss().Health = self.BossHealth
				local boss = GetBoss()
				boss:Destroy()
				SetBoss(ffi.cast("ObjectA*", 0))
			end
		end
	end
	 	
end
end

function attack(self)
	local claw = GetClaw()
	--local attempt = Attempt()
	local state = claw.State
	
	if self.StartCondition == nil then
		self.stage = 0
		self.StartCondition = 1
	end
	--elseif attempt > self.lastattempt then
	--	self.lastattempt = attempt
	--	self.stage = 12
	--end
	
end