local A1, A2 = 727595, 798405  -- 5^17=D20*A1+A2
local D20, D40 = 1048576, 1099511627776  -- 2^20, 2^40
local X1, X2 = 0, 1
function rand()
    local U = X2*A2
    local V = (X1*A2 + X2*A1) % D20
    V = (V*D20 + U) % D40
    X1 = math.floor(V/D20)
    X2 = V - X1*D20
    return V/D40
end

function det(a,b,c, d,e,f, g,h,i)
  return a*e*i+b*f*g+c*d*h-c*e*g-b*d*i-a*f*h
end

function GetJumpTrajectory(x1,y1, x2,y2, x3,y3)
  local DET = det(x1*x1, x1, 1, x2*x2, x2, 1, x3*x3, x3, 1)
  local res = {}
  res[0] = det(y1, x1, 1, y2, x2, 1, y3, x3, 1)/DET
  res[1] = det(x1*x1, y1, 1, x2*x2, y2, 1, x3*x3, y3, 1)/DET
  res[2] = det(x1*x1, x1, y1, x2*x2, x2, y2, x3*x3, x3, y3)/DET
  return res
end

function main(self)

	if self.State == 0 then
	
		self.StartX = self.X
		self.StartY = self.Y
		
		self.TargetX = GetClaw().X + 12.0 * rand() - 6.0
		if math.abs(self.TargetX - self.StartX) < 8.0 then
			if self.TargetX >= self.StartX then
				self.TargetX = self.TargetX + 8.0
			else
				self.TargetX = self.TargetX - 8.0
			end
		end
		
		self.TargetY = 5350
	
		self.XDiff = self.TargetX - self.StartX
	
		self.FlyTime = GetTime()
		self.FlyLimit = GetTime() + 1000.0
	
		self.FlyMaxX = ( self.TargetX + self.StartX ) / 2.0
		self.FlyMaxY = 5200.0
	
		local tab = GetJumpTrajectory(self.StartX, self.StartY, self.TargetX, self.TargetY, self.FlyMaxX, self.FlyMaxY)
		self.FlyA = tab[0]
		self.FlyB = tab[1]
		self.FlyC = tab[2]
	
		self.State = 1
	end


	local Time = GetTime()
	local Progress = ( Time - self.FlyTime ) / ( self.FlyTime - self.FlyLimit ) * (-1)
	local x = self.StartX + self.XDiff * Progress
	self.X = x
	self.Y = self.FlyA * x * x + self.FlyB * x + self.FlyC
	
	self.I = math.ceil(Progress*2 + 0.5)
	
	self:SetFrame(self.I)
	
	if Progress >= 1 then
		self.tnt = CreateObject {x=self.X, y=self.Y-16, z=5000, name="Explosion", logic="CustomLogic", image="GAME_DYNAMITELIT"}
		self:Destroy()
	end
	
	
	
end



