local A1, A2 = 727595, 798405  -- 5^17=D20*A1+A2
local D20, D40 = 1048576, 1099511627776  -- 2^20, 2^40
local X1, X2 = 0, 1
function rand()
    local U = X2*A2
    local V = (X1*A2 + X2*A1) % D20
    V = (V*D20 + U) % D40
    X1 = math.floor(V/D20)
    X2 = V - X1*D20
    return V/D40
end
function det(a,b,c, d,e,f, g,h,i)
  return a*e*i+b*f*g+c*d*h-c*e*g-b*d*i-a*f*h
end
function GetJumpTrajectory(x1,y1, x2,y2, x3,y3)
  local DET = det(x1*x1, x1, 1, x2*x2, x2, 1, x3*x3, x3, 1)
  local res = {}
  res[0] = det(y1, x1, 1, y2, x2, 1, y3, x3, 1)/DET
  res[1] = det(x1*x1, y1, 1, x2*x2, y2, 1, x3*x3, y3, 1)/DET
  res[2] = det(x1*x1, x1, y1, x2*x2, x2, y2, x3*x3, x3, y3)/DET
  return res
end

-- States:
-- 0 - initialization
-- 1 - between attacks
-- 2 - getting hit
-- 3 - firing gun
-- 4 - kicking
-- 5 - ground knives throw
-- 6 - reposition
-- 7 - air knives throw


function LookAtClaw(self)
	if self.X > GetClaw().X then
		self.DrawFlags.Mirror = false
	else
		self.DrawFlags.Mirror = true
	end
end

function main(self)
--if GetClaw().Health > 0 then 
	if self.DrawFlags.Mirror then
		self.dir = 1
	else
		self.dir = -1
	end
	if self.State == 0 then
	
		self.X = 83770
		self.Y = 5290
			
  		self.Health = 100
		self.Damage_Gun = 10
		self.Damage_Kick = 10
		self.Damage_Touch = 5
		self.Damage_Knife = 5
		self.Damage = self.Damage_Touch -- Melee
		self.XMin = 83460
		self.XMax = 83770
		self.YMin = 5000
		self.YMax = 5300
		self.Shot = 0
		self.WindTimeCounter = GetTime()
		
		self.Stage = 0
		
		self.ObjectTypeFlags = 4
		self.WpierdolCounter = 0
		self.QuickReloadCounter = 2
		
		self.NormalReload = 1700
		self.QuickReload = 500
		
		self.I = 100
		self:SetImage("LEVEL_REDTAIL")
		self:SetAnimation("LEVEL_REDTAIL_IDLE")
		self.Z = 4001
		
		--self.AttackCooldown = 1500
		self.TimeCounter = GetTime() + self.NormalReload
		
		self.HitTypeFlags = 50335794
		--self.HitTypeFlags = ObjectType.Player + ObjectType.PShot
		self.HitRect = {-32,-40,32,64}
		
        self.AttackTypeFlags = ObjectType.Player
		self.DefaultAttackRect = {-16,-8,16,16}
		self.AttackRect = self.DefaultAttackRect
		
		if self.RTWind == nil then
			self.RTWind = CreateObject {x=83637, y=5326, z=10000, logic="ConveyorBelt", image="GAME_SOUNDICON", Speed = 0}
			self.RTWind.DrawFlags.NoDraw = true
			--self.RTWind.HitRect = {-512,-32,512,64}
			self.RTWind.MoveRect = {-256,-32,256,64}
		else
			self.RTWind.Speed = 0
		end
		--self.RTWind.MoveClawX = 50
		
		self.State = 1
	elseif self.State == 1 then -- 1 - between attacks
		local claw = GetClaw()
		if claw.State == 5009 or claw.Health <= 0 then -- wait for battle to start
			self.TimeCounter = GetTime() + self.NormalReload
		end
  		if self.TimeCounter < GetTime() then
			--TextOut(self.I)
			local r = rand()
			if math.abs(self.X - claw.X) > 68 then -- if Claw is in distance, fire gun or throw knives
				if GetClaw().State ~= 26 and r < 0.5 then
					self.State = 3
					LookAtClaw(self)
					self:SetAnimation("LEVEL_REDTAIL_STRIKE4")
					self.TimeCounter = GetTime() + self.NormalReload
				elseif r < 0.75 then
					self.State = 5
					LookAtClaw(self)
					self:SetAnimation("LEVEL_REDTAIL_STRIKE2")
					self.TimeCounter = GetTime() + self.NormalReload
				else
					self.State = 7
					LookAtClaw(self)
					self:SetAnimation("LEVEL_REDTAIL_STRIKE2")
					self.TimeCounter = GetTime() + self.NormalReload
				end
			end
		end
		if self.TimeCounter < GetTime() then
			--TextOut(self.I)
			local r = rand()
			if math.abs(self.X - claw.X) <= 120 then -- if Claw is close, kick him
				self.State = 4
				LookAtClaw(self)
				self:SetAnimation("LEVEL_REDTAIL_STRIKE8")
				--self.TimeCounter = GetTime() + 1000
			end
		end
		if self.WpierdolCounter >= 2 then
			self.WpierdolCounter = 0
			self.State = 6 -- reposition
			self.I = 800
			local mid = ( self.XMin + self.XMax ) / 2
			local targetX = nil
			if self.X < mid then
				targetX = self.XMax
			else
				targetX = self.XMin
			end
			self.FlyTime = GetTime()
			self.FlyLimit = GetTime() + 800
			self.StartX = self.X
			self.StartY = self.Y
			self.XDiff = targetX - self.StartX
			local tab = GetJumpTrajectory(self.StartX, self.StartY, targetX, self.YMax, mid, self.YMin)
			self.FlyA = tab[0]
			self.FlyB = tab[1]
			self.FlyC = tab[2]
			PlaySound("LEVEL_REDTAIL_RTJUMP")
		end
	elseif self.State == 2 then -- 2 - getting hit
		if self.I == 200 then
			self.State = 1
			self:SetAnimation("LEVEL_REDTAIL_IDLE")
			self.TimeCounter = GetTime() + 1000
		end
	elseif self.State == 3 then -- 3 - firing gun
		if self.I == 209 and self.Shot == 0 then
			PlaySound("LEVEL_REDTAIL_FLAREGUN3")
			
			CreateObject {x=self.X + self.dir*64, y=self.Y-10, z=4100, logic="RedTailBullet", image="LEVEL_REDTAILBULLET", SpeedX = 580*self.dir, Damage = 10}
			
			self.Shot = 1
		end
		if self.I == 207 and self.Shot == 1 then
			
			self.Shot = 0
			self.State = 1
			self:SetAnimation("LEVEL_REDTAIL_IDLE")
			if self.QuickReloadCounter > 0 then
				self.TimeCounter = GetTime() + self.NormalReload
				self.QuickReloadCounter = self.QuickReloadCounter - 1
			else
				self.TimeCounter = GetTime() + self.QuickReload
				self.QuickReloadCounter = 2
			end
		end
	elseif self.State == 4 then -- 4 - kicking 
		if self.I == 402 then
			if self.dir == 1 then
				self.AttackRect = {-16,-8,40,16}
			else
				self.AttackRect = {-48,-8,16,16}
			end
			self.Damage = self.Damage_Kick
		end
		if self.I == 200 then
			self.AttackRect = self.DefaultAttackRect
			self.Damage = self.Damage_Touch
			self.State = 1
			self:SetAnimation("LEVEL_REDTAIL_IDLE")
			self.TimeCounter = GetTime() + self.QuickReload
		end
	elseif self.State == 5 then -- 5 - ground knives throw
		if self.I == 204 and self.Shot == 0 then
			PlaySound("LEVEL_REDTAIL_3KNIVES")
			self.spike1 = CreateObject {x=self.X + self.dir*64, y=self.Y-10, z=4100, logic="Bullet", image="LEVEL_REDTAILKNIFE", SpeedX = 349*self.dir, SpeedY = 31, Damage = 5, ObjectTypeFlags = 64}
			self.spike2 = CreateObject {x=self.X + self.dir*64, y=self.Y-10, z=4100, logic="Bullet", image="LEVEL_REDTAILKNIFE", SpeedX = 338*self.dir, SpeedY = 91, Damage = 5, ObjectTypeFlags = 64}
			self.spike3 = CreateObject {x=self.X + self.dir*64, y=self.Y-10, z=4100, logic="Bullet", image="LEVEL_REDTAILKNIFE", SpeedX = 317*self.dir, SpeedY = 148, Damage = 5, ObjectTypeFlags = 64}	
			if self.dir == 1 then
				self.spike1:SetFrame(10)
				self.spike2:SetFrame(9)
				self.spike3:SetFrame(9)
			else
				self.spike1:SetFrame(4)
				self.spike2:SetFrame(5)
				self.spike3:SetFrame(5)
			end
			
			self.TimeCounter2 = GetTime()
			self.Shot = 1
		end
		if self.I == 204 and self.Shot == 1 then
			if self.TimeCounter2 + 200 < GetTime() then -- let animation finish properly
				self.Shot = 0
				self.State = 1
				self:SetAnimation("LEVEL_REDTAIL_IDLE")
				
				if self.QuickReloadCounter > 0 then
					self.TimeCounter = GetTime() + self.NormalReload
					self.QuickReloadCounter = self.QuickReloadCounter - 1
				else
					self.TimeCounter = GetTime() + self.QuickReload
					self.QuickReloadCounter = 2
				end
			end
		end
	elseif self.State == 7 then -- 7 - air knives throw
		if self.I == 204 and self.Shot == 0 then
			PlaySound("LEVEL_REDTAIL_3KNIVES")
			self.spike1 = CreateObject {x=self.X + self.dir*64, y=self.Y-10, z=4100, logic="Bullet", image="LEVEL_REDTAILKNIFE", SpeedX = 350*self.dir, Damage = 5, ObjectTypeFlags = 64}
			self.spike2 = CreateObject {x=self.X + self.dir*64, y=self.Y-10, z=4100, logic="Bullet", image="LEVEL_REDTAILKNIFE", SpeedX = 345*self.dir, SpeedY = -60, Damage = 5, ObjectTypeFlags = 64}
			self.spike3 = CreateObject {x=self.X + self.dir*64, y=self.Y-10, z=4100, logic="Bullet", image="LEVEL_REDTAILKNIFE", SpeedX = 329*self.dir, SpeedY = -120, Damage = 5, ObjectTypeFlags = 64}
			if self.dir == 1 then
				self.spike1:SetFrame(10)
				self.spike2:SetFrame(10)
				self.spike3:SetFrame(11)
			else
				self.spike1:SetFrame(4)
				self.spike2:SetFrame(4)
				self.spike3:SetFrame(3)
			end
			
			self.TimeCounter2 = GetTime()
			self.Shot = 1
		end
		if self.I == 204 and self.Shot == 1 then
			if self.TimeCounter2 + 200 < GetTime() then -- let animation finish properly
				self.Shot = 0
				self.State = 1
				self:SetAnimation("LEVEL_REDTAIL_IDLE")
				
				
				if self.QuickReloadCounter > 0 then
					self.TimeCounter = GetTime() + self.NormalReload
					self.QuickReloadCounter = self.QuickReloadCounter - 1
				else
					self.TimeCounter = GetTime() + self.QuickReload
					self.QuickReloadCounter = 2
				end
			end
		end
	elseif self.State == 6 then -- 6 - reposition
		if GetTime() >= self.FlyTime and GetTime() <= self.FlyLimit then 
			--self.I = 801
			local Time = GetTime()
			local Progress = ( Time - self.FlyTime ) / ( self.FlyTime - self.FlyLimit ) * (-1)
			--TextOut(Progress)
			local x = self.StartX + self.XDiff * Progress
			self.X = x
			self.Y = self.FlyA * x * x + self.FlyB * x + self.FlyC
			if Progress >= 0.05 and Progress < 0.5 then
				self.I = 801
			end
			if Progress >= 0.5 then
				if self.I == 801 then
					PlaySound("LEVEL_REDTAIL_3KNIVES")
					self.spike1 = CreateObject {x=self.X + self.dir*64, y=self.Y-10, z=4100, logic="Bullet", image="LEVEL_REDTAILKNIFE", SpeedY = 450, Damage = 5, ObjectTypeFlags = 64}
					self.spike2 = CreateObject {x=self.X + self.dir*64, y=self.Y-10, z=4100, logic="Bullet", image="LEVEL_REDTAILKNIFE", SpeedX = -225, SpeedY = 390, Damage = 5, ObjectTypeFlags = 64}
					self.spike3 = CreateObject {x=self.X + self.dir*64, y=self.Y-10, z=4100, logic="Bullet", image="LEVEL_REDTAILKNIFE", SpeedX = 225, SpeedY = 390, Damage = 5, ObjectTypeFlags = 64}
					self.spike1:SetFrame(7)
					self.spike2:SetFrame(6)
					self.spike3:SetFrame(8)					
				end
				self.I = 802
			end
		end
		if GetTime() > self.FlyLimit then
				if self.Stage == 0 and self.Health <= 75 then
					self.Stage = 1
					
					local mid = ( self.XMin + self.XMax ) / 2
					if self.X < mid then
						PlaySound("LEVEL_REDTAIL_01040020")
						self.RTWind.Speed = 300
					else
						PlaySound("LEVEL_REDTAIL_01040012")
						self.RTWind.Speed = -300
					end
					self.WindTimeCounter = GetTime() + 8497
					PlaySound("LEVEL_REDTAIL_WINDWHISTLING")
				end
				if self.Stage == 1 and self.Health <= 50 then
					self.Stage = 2
					
					local mid = ( self.XMin + self.XMax ) / 2
					if self.X < mid then
						PlaySound("LEVEL_REDTAIL_01040020")
						self.RTWind.Speed = 300
					else
						PlaySound("LEVEL_REDTAIL_01040012")
						self.RTWind.Speed = -300
					end
					self.WindTimeCounter = GetTime() + 8497
					PlaySound("LEVEL_REDTAIL_WINDWHISTLING")
				end
				if self.Stage == 2 and self.Health <= 25 then
					self.Stage = 3
					
					local mid = ( self.XMin + self.XMax ) / 2
					if self.X < mid then
						PlaySound("LEVEL_REDTAIL_01040020")
						self.RTWind.Speed = 300
					else
						PlaySound("LEVEL_REDTAIL_01040012")
						self.RTWind.Speed = -300
					end
					self.WindTimeCounter = GetTime() + 8497
					PlaySound("LEVEL_REDTAIL_WINDWHISTLING")
				end
				self.State = 1
				self:SetAnimation("LEVEL_REDTAIL_IDLE")
				self.TimeCounter = GetTime() + self.QuickReload
				LookAtClaw(self)
			end
	end
	if self.WindTimeCounter <= GetTime() then
		self.RTWind.Speed = 0
	end
	self:SetFrame(self.I)
	self:AnimationStep()
	--TextOut(self.TimeCounter-GetTime())
--end
end

function hit(self)
	
	--local claw = GetClaw()
	--if self.State == 1 then
		
		--TextOut(self.HitRef.ObjectTypeFlags)
		if self.HitRef.ObjectTypeFlags == 2 and self.State == 1 then
			self.State = 2
			if rand() < 0.5 then
				self:SetAnimation("LEVEL_REDTAIL_HITLOW")
			else
				self:SetAnimation("LEVEL_REDTAIL_HITHIGH")
			end
			if rand() < 0.5 then
				PlaySound("LEVEL_REDTAIL_01040006")
			else
				PlaySound("LEVEL_REDTAIL_01040007")
			end
			local r = rand()
			if r<0.25 then
				PlaySound("GAME_HIT1")
			elseif r<0.5 then
				PlaySound("GAME_HIT2")
			elseif r<0.75 then
				PlaySound("GAME_HIT3")
			else
				PlaySound("GAME_HIT4")
			end
			if GetClaw().State == 26 then
				self.Health = self.Health - 3
			else
				self.Health = self.Health - 5
			end
			self.WpierdolCounter = self.WpierdolCounter + 1
		elseif self.HitRef.ObjectTypeFlags == 32 or self.HitRef.Logic==Dynamite then
			self.HitRef.Y = 9000
			PlaySound("LEVEL_REDTAIL_BLOCK2")
			self.QuickReloadCounter = 2
			if self.TimeCounter-GetTime() < self.NormalReload then
				self.TimeCounter = self.TimeCounter + 500
			else
				self.TimeCounter = GetTime() + self.NormalReload + 500
			end
		elseif self.HitRef.Logic==MagicBullet then
			self.HitRef.Y = 9000
			PlaySound("LEVEL_REDTAIL_BLOCK2")
			self.QuickReloadCounter = 2
			self.TimeCounter = GetTime() + self.NormalReload + 500
		end
		--TextOut(GetClaw().State)
		
		
	--end
end 

--function attack(self)
	--PlaySound("CLAW_FIRESWORD")
	--PlaySound("GAME_HIT2")
	--self.obj101 = CreateObject {x=self.X-1, y=self.Y-2, z=950, I=-1, logic="SimpleAnimation", image="GAME_EXPLOS_FIRE", UserRect1 = {0,0,0,0}, UserRect2 = {0,0,0,0}}
	--ClawSound("CUSTOM_TRIGGER_1000")
	--ClawJump(128)
	
	--if(self.AttackOnceFlag == 0 and GetClaw().State ~= 31) then
		--self.AttackOnceFlag = 1
		--ClawTakeDamage(5)
		--GetClaw().Height = 23
	--end
	
	
	
--end















